﻿/*
* TanKy Mobil Chess by tomitank
* Date:2016.07.06.
* Author:tomitank [Kuzmics Tamas]
* Contact:tomitank@freemail.hu , tanky.hu@gmail.com
* [^:]//.* regular search->comment del
*/


	var path = ''; // gyoker mappa
	var verzio = '1.6.5'; // verzio
	var musicOff = false; // zene ?
	var soundOff = false; // hang ?
	var globalSound = null; // hang
	var lastOnline = false; // net?
	var globalMusic = null; // zene
	var helpLoop = false; // segit?
	var gameMode = 1; // gep vagy 1v1
	var yourSide = 0; // Feherrel kezd
	var brd_bookLines = []; // Open book
	var OLD_PIECE_NUM = 32; // babuk szama
	var LEPES_ELOZMENYEK = []; // nyitashoz kell
	var JATEK_FOLYAMATBAN = true; // jatek folyamatban ?
	var EXTREM_WORKER_NELKUL = false; // extrem worker nelkul KI
	var ALPHA_BETA_MAX_IDO = 2000; // maximalis vizsgalati ido (2mp)
	var FEN = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 0';





	// HTML betoltodott
		$(document).ready(function() {

		// Nyitas konyv betoltese
			$.ajax({
				url : "sakk_openBook.txt",
				cache : false,
				success: function (txt) {
					$(txt).find('line').each(function() {
						var trimmed = $(this).text();
						trimmed = $.trim(trimmed);
						brd_bookLines.push(trimmed);
					});
				}
			});

		// status bar eltuntetese
			$('*').click(function() {
				if (path != '') StatusBar.hide(); // betoltodott a cordova.js
			});

		// Hangok a menu lapozasnal
			$('#menu_button a, #game_resume a, #game_play a').click(function() {
				playAudio('menu_slash.mp3', '0.2');
			});

		// Hangok a gomboknal
			$('#game_buttons a, #game_music a, #game_side a').click(function() {
				playAudio('button_click.mp3', '0.2');
			});

			drawBoard(CHESS_BOARD); // tabla kirjazolasa
			$('select').val('2000'); // Erosseg alaphelyzetbe ujratoltaskor

			document.addEventListener("pause", pauseApp, false); // Ha hatterbe kerul az alkalmazas
			document.addEventListener("resume", resumeApp, false); // Ha ujra fut az alkalmazas
			document.addEventListener("online", onOnline, false); // Ha van internet-kapcsolat
		    document.addEventListener("deviceready", onDeviceReady, false); // cordova.js betoltodott

		});





	// global ertesito
		function global_info(html) {
			var wtop = (document.documentElement.clientHeight-312) / 2;
			var wleft = (document.documentElement.clientWidth-312) / 2;

			if (!wtop || !wleft || wtop <= 0 || wleft <= 0) { // bugfix
				var wtop = 10;
				var wleft = 10;
			}

			var end_html = '<div id="global_menu">';
			end_html += '<div id="global_menu_info">TanKy.hu Sakk</div>';
			end_html += '</div>';
			end_html += '<div class="clear"></div>';
			end_html += '<div id="global_info">'+html+'</div>';

			$("#global_alert").html(end_html).css({'display': 'block', 'left': wleft, 'top': wtop}).draggable({'cancel': '#global_info, img'});
		}





	// global ertesito bezaras
		function global_info_close() {
			$("#global_alert").html('').css({'display': 'none'});
		}





	// cordova.js betoltodott
		function onDeviceReady() {
			path = window.location.pathname; // gyoker konyvtar megallapitasa
			path = path.substr( path, path.length - 10 ); // gyoker konyvtar megallapitasa

			globalMusic = new Media(path + "sound/mozart.mp3", null, null, playMusic);

			if (device.platform == 'iOS') { // iOS-nel lezaraskor ne szoljon a zene
				globalMusic.play({ playAudioWhenScreenIsLocked : false });
				globalMusic.setVolume('0.2'); // Hangero iOS-nel
			} else { // Android, Winphone
				globalMusic.play();
			}

			StatusBar.hide(); // status bar eltuntetese
		}





	// Az alkalmazassal kapcsolatos uzenet es reklamok a felhasznalonak, ha van internetkapcsolat
		function onOnline(update, adds) {
			if (!lastOnline || update || adds)
			{
				$.ajax({
					type: "POST",
					url : "http://mobil.tanky.hu/appInfo/mobilAppInfo.php",
					cache : false,
					data: {"verzio": verzio, "eszkoz": device.platform, "model": device.model, 'ready': (lastOnline ? 'yes' : 'no') },
					success: function (info) {
						if (info != '') {
							if (info.substr(0, 1) == '!' && !adds) { // Ha frissites van
								return navigator.notification.confirm(
									info.substr(1), // Uzenet
									gameUpdate, // Funkcio
									'Frissítés', // Cim
									['Letöltöm', 'Késöbb'] // Gomb
								);
							} else if (info.substr(0, 1) == '*') { // Ha reklam van

								if ($("#global_alert").html() == '') { // Csak ha ures a box! (Gyalobevaltas)
									global_info(info.substr(1));
								}

							} else if (info.substr(0, 1) == '#') { // Info kozlese
								return navigator.notification.alert(
									info.substr(1), // Uzenet
									false, // Funkcio
									'Információ', // Cim
									'Rendben' // Gomb
								);
							}
						}
					}
				});

				lastOnline = true; // dupla meghivas vedelem
			}
		}





	// Az alkalmazasfrissites felajanlasa, ha van internetkapcsolat
		function gameUpdate(gomb) {
			if (gomb == 1) {
				if (device.platform == 'Android') {
					window.open('https://play.google.com/store/apps/details?id=hu.tanky.sakk', '_system');
				} else if (device.platform == 'iOS') {
					// iOS link
				} else {
					// WP link
				}

				return navigator.notification.alert(
					'A letöltés után ne felejtsd el telepíteni a frissítést!', // Uzenet
					false, // Funkcio
					'Információ', // Cim
					'Rendben' // Gomb
				);
			}
		}





    // alkalmazas hatterbe
		function pauseApp(status) {
			if (path == '') return false; // nem tudott betoltodni a cordova.js

			if (globalMusic != null) globalMusic.pause(); // zene szuneteltetese amikor hatterbe kerul az alkalmazas
		}





    // alkalmazas folytatasa
		function resumeApp(status) {
			if (path == '') return false; // nem tudott betoltodni a cordova.js

			StatusBar.hide(); // status bar eltuntetese

			document.addEventListener("online", onOnline(true, false), false); // Ha van internet-kapcsolat

			if (musicOff === true) return false; // ki van kapcsolva a zene

			if (globalMusic == null) { // hatterzene ujratoltese, ha valami miatt megszakadt volna a hatterbe lepeskor
				globalMusic = new Media(path + "sound/mozart.mp3", null, null, playMusic);
			}

			// zene folytatasa vagy elinditasa amikor ujra megnyilik az alkalmazas
			// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

			if (device.platform == 'iOS') { // iOS-nel lezaraskor ne szoljon a zene
				globalMusic.play({ playAudioWhenScreenIsLocked : false });
				globalMusic.setVolume('0.2'); // Hangero iOS-nel
			} else { // Android, Winphone
				globalMusic.play();
			}
		}





    // zene elinditasa es ujrainditasa(loop)
		function playMusic(status) {
			if (status == Media.MEDIA_STOPPED && musicOff === false) {

				globalMusic.release(); // Tarolo uritese

				globalMusic = new Media(path + "sound/mozart.mp3", null, null, playMusic);

				if (device.platform == 'iOS') { // iOS-nel lezaraskor ne szoljon a zene
					globalMusic.play({ playAudioWhenScreenIsLocked : false });
					globalMusic.setVolume('0.2'); // Hangero iOS-nel
				} else { // Android, Winphone
					globalMusic.play();
				}
			}
		}





	// Hang lejatszas
		function playAudio(src, volume) {
			if (path == '') return false; // nem tudott betoltodni a cordova.js
			if (soundOff === true) return false; // ki van kapcsolva a hang
			if (globalSound !== null) { globalSound.stop(); globalSound.release(); } // elozo hang leallitasa
			if (device.platform == 'iOS' && musicOff === false) globalMusic.pause(); // iOS-nel meg kell allitani a hatter zenet

			globalSound = new Media(path + "sound/"+src , function() { // kesz
															globalSound.release(); // tarolo uritese
															if (device.platform == 'iOS' && musicOff === false) // iOS-nel folytatjuk a zenet
															globalMusic.play({ playAudioWhenScreenIsLocked : false });
														}
														, function() {} // hiba
														, null // statusz
													);

			if (volume) {
				globalSound.setVolume(volume); // Hangero allitasa ha adtunk ilyen parametert
			} else {
				globalSound.setVolume('1.0'); // Hangero allitasa ha adtunk ilyen parametert
			}

			globalSound.play(); // hang lejatszasa
		}





    // jatek zene be/ki
		function musicChange() {
			if (musicOff === true) { // zene be

				musicOff = false;
				$('#game_music .toggle_icon').attr('src','pic/toggle_on.png');

				if (path == '') return false; // nem tudott betoltodni a cordova.js

				if (globalMusic == null) { // hatterzene ujratoltese, ha sikeresen kinullaztuk volna
					globalMusic = new Media(path + "sound/mozart.mp3", null, null, playMusic);
				}

				if (device.platform == 'iOS') { // iOS-nel lezaraskor ne szoljon a zene
					globalMusic.play({ playAudioWhenScreenIsLocked : false });
					globalMusic.setVolume('0.2'); // Hangero iOS-nel
				} else { // Android, Winphone
					globalMusic.play();
				}

			} else { // zene ki

				musicOff = true;
				$('#game_music .toggle_icon').attr('src','pic/toggle_off.png');

				if (globalMusic != null) {
					globalMusic.stop(); // zene leallitasa
					globalMusic.release(); // Tarolo uritese
					globalMusic = null; // valtozo alaphelyzetbe
				}
			}
		}





    // jatek hang be/ki
		function soundChange() {
			if (soundOff === true) { // hang be
				soundOff = false;
				playAudio('button_click.mp3', '0.2'); // hang a bekapcsolaskor
				$('#game_sound .toggle_icon').attr('src','pic/toggle_on.png');
			} else {
				soundOff = true; // hang ki
				$('#game_sound .toggle_icon').attr('src','pic/toggle_off.png');
			}
		}





    // oldal csere
		function sideChange() {

			if (yourSide === 0) // Forditott felallas (fekete lent)
			{
				yourSide = 8; // felallas csere

				$('#player_1_side').animate({'left': '+='+105}, 300, false); // feher oldal csere
				$('#player_2_side').animate({'right': '+='+105}, 300, false); // fekete oldal csere
			} 
			else  // Alap felallas (feher lent)
			{
				yourSide = 0; // felallas csere

				$('#player_1_side').animate({'left': '-='+105}, 300, false); // feher oldal vissza
				$('#player_2_side').animate({'right': '-='+105}, 300, false); // fekete oldal vissza
			}

		}





    // jatek menu kezelese
		function gameMenu(id) {
			
		// aminamciok
			var anim_diff_1 = $('#main').css('width'); // 1. animacio differencia
			var anim_diff_2 = anim_diff_1.split('px');
			anim_diff_2 = (parseInt(anim_diff_2[0]) * 2)+'px'; // 2. animacio differencia
			var anim_diff_3 = anim_diff_1.split('px');
			anim_diff_3 = (parseInt(anim_diff_3[0]) * 3)+'px'; // 3. animacio differencia

		// menupontok
			if (id == 'open') { // JATEKMODOK FUL LENYITASA/BECSUKASA A FOMENUBEN

				if ( $('#game_mode').is(":hidden") ) {
					$('#game_mode').slideDown('fast', function() { }); // lenyitas
				} else {
					$('#game_mode').slideUp('fast', function() { }); // becsukas
				}

				return false; // kilepunk

			} else if (id == 'single') { // GEP ELLEN BEALLITAS MENU

				var oldGameMode = gameMode; // eredeti jatekmod mentese
				gameMode = 1; // gep ellen jatszunk

				if (!Game_Restart(3)) { // ha nem kezdtunk uj merkozest
					gameMode = oldGameMode; // eredeti jatekmodot vissza
					return false;
				}

				playAudio('menu_slash.mp3', '0.2'); // menu lapozas hang

				$('#content').css({'width': anim_diff_3}); // content 3 ablak
				$('#game_power').css({'display':'block'}); // erosseg allitas be
				$('#new_game_menu').css({'display':'block'}); // jatek beallitas be
				$('#side_name_1').html('Én').removeClass('small'); // 1.jatekos kiiras csere
				$('#side_name_2').html('Gép').removeClass('small'); // 2.jatekos kiiras csere
				$('#gep_erosseg_big div, #gep_erosseg_small div, #game_help').removeClass('hidden'); // gep erosseg allito, segiseg gomb be

				$('#content').animate({'margin-left': '-'+anim_diff_1, 'width': anim_diff_3}, 300, function() { // uj jatek menu megnyitasa
					$('#logo').removeClass('menu_logo'); // logo oldalra kerul
					$('#welcome').css({'display':'block'}); // udvozlo szoveg be
					$('#game_resume').css({'display':'none'}); // vissza a jatekba ki
					$('#menu_button').css({'display':'block'}); // menu gomb megjelenitese
				});

				return true; // kilepunk

			} else if (id == 'multi') { // 2 JATEKOS MOD BEALLITAS MENU

				var oldGameMode = gameMode; // eredeti jatekmod mentese
				gameMode = 2; // 1v1 modban jatszunk

				if (!Game_Restart(3)) { // ha nem kezdtunk uj merkozest
					gameMode = oldGameMode; // eredeti jatekmodot vissza
					return false;
				}

				playAudio('menu_slash.mp3', '0.2'); // menu lapozas hang

				$('#content').css({'width': anim_diff_3}); // content 3 ablak
				$('#game_power').css({'display':'none'}); // erosseg allitas ki
				$('#new_game_menu').css({'display':'block'}); // jatek beallitas be
				$('#side_name_1').html('1.Játékos').addClass('small'); // 1.jatekos kiiras csere
				$('#side_name_2').html('2.Játékos').addClass('small'); // 2.jatekos kiiras csere
				$('#gep_erosseg_big div, #gep_erosseg_small div, #game_help').addClass('hidden'); // gep erosseg allito, segiseg gomb ki

				$('#content').animate({'margin-left': '-'+anim_diff_1}, 300, function() { // uj jatek menu megnyitasa
					$('#logo').removeClass('menu_logo'); // logo oldalra kerul
					$('#welcome').css({'display':'block'}); // udvozlo szoveg be
					$('#game_resume').css({'display':'none'}); // vissza a jatekba ki
					$('#menu_button').css({'display':'block'}); // menu gomb megjelenitese
				});

				return true; // kilepunk

			} else if (id == 'play') { // BELEPUNK AZ UJ JATEKBA

				if (Game_Restart(4)) // elinditjuk az uj jatekot
				{
					$('#content').animate({'margin-left': '-'+anim_diff_2}, 300, function() { // jatekoldal megnyitasa

						// EGYIDOBEN FUTNAK LE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
						$('#content').animate({'margin-left': '-'+anim_diff_1, 'width': anim_diff_2}, 0, false); // content 2 ablak

						$('#new_game_menu').animate({'width': '0px'}, 0, false, function() { // jatek beallitas menu >> 0px
							$('#welcome').css({'display':'none'}); // udvozles eltunik
							$('#game_resume').css({'display':'block'}); // folytatas gomb be
							$('#new_game_menu').css({'display':'none', 'width': anim_diff_1}); // uj jatek ki + szelesseg novelese
						});
						// EGYIDOBEN FUTNAK LE >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

					});
				} else {
					alert('Hiba! Indítsd újra az alkalmazást!')
				}

				return true; // kilepunk

			} else if (id == 'resume') { // MEGKEZDETT JATEK FOLYTATASA

				$('#content').animate({'margin-left': '-'+anim_diff_1}, 300, function() { // jatekoldal megnyitasa
					$('#logo').removeClass('menu_logo'); // logo oldalra kerul
					$('#menu_button').css({'display':'block'}); // menu gomb megjelenitese
				});

				return true; // kilepunk

			} else if (id == 'menu') { // FOMENUBE LEPES

				$('#logo').addClass('menu_logo'); // fomenuben kozepen van a logo
				$('#game_mode').css({'display':'none'}); // jatekmodok menu ful ki
				$('#menu_button').css({'display':'none'}); // menugomb eltuntetese
				$('#content').animate({'margin-left': '0px'}, 300, function() { }); // fomenu megnyitasa

				return true; // kilepunk
			}
		}





    // jatek statisztika
		function gameStat() {
			if (path == '') return false; // nem tudott betoltodni a cordova.js
			var best_stat = window.localStorage.getItem("best_stat");
			var vereseg_stat = window.localStorage.getItem("vereseg_stat");
			var gyozelem_stat = window.localStorage.getItem("gyozelem_stat");
			var dontetlen_stat = window.localStorage.getItem("dontetlen_stat");

			return navigator.notification.confirm(
				'Legjobb szint: '+(best_stat ? best_stat : 'Nincs')+
				'\r\nGyőzelmek: '+(gyozelem_stat ? gyozelem_stat : 0)+
				'\r\nVereségek: '+(vereseg_stat ? vereseg_stat : 0)+
				'\r\nDöntetlenek: '+(dontetlen_stat ? dontetlen_stat : 0), // Uzenet
				gameStatClear, // Funkcio
				'Statisztika', // Cim
				['Rendben', 'Nullázás'] // Gomb
			);
		}





    // statisztika torles megerositese
		function gameStatClear(gomb) {
			if (path == '') return false; // nem tudott betoltodni a cordova.js
			if (gomb == 2) {
				navigator.notification.beep(1);
				navigator.notification.confirm(
					'Biztos törölni szeretnéd?', // Uzenet
					gameStatDel, // Funkcio
					'Megerosítés', // Cim
					['Igen', 'Nem'] // Gomb
				);
			}
		}





    // statisztika torles megerositese
		function gameStatDel(gomb) {
			if (path == '') return false; // nem tudott betoltodni a cordova.js
			if (gomb == 1) {
				//window.localStorage.clear(); // mindent torol
				window.localStorage.removeItem("best_stat"); // torles
				window.localStorage.removeItem("vereseg_stat"); // torles
				window.localStorage.removeItem("gyozelem_stat"); // torles
				window.localStorage.removeItem("dontetlen_stat"); // torles

				navigator.notification.alert(
					'Statisztika törölve!', // Uzenet
					false, // Funkcio
					'Végrehajtva', // Cim
					'Rendben' // Gomb
				);
			}
		}





	// Uj jatek
		function Game_Restart(id) {

			if (id == 2) return false; // bezaras gombra nyomtak a felugro ablakon

			var worker_kereses = false; // volt-e worker kereses folyamatban

			if (maxSearchTime !== 0) { // ha epp keres a gep
				if (InitializeBackgroundEngine()) { // Worker eseten a hatter futtatas leallitasa
					worker_kereses = true;
					maxSearchTime = 0;
					WorkerStop();
				} else { // Worker nelkul meg kell varnunk a kereses veget (elvileg nem tudunk kattintani sehova)
					alert('Várd meg a keresést!');
					return false;
				}
			}

			if (id != 0 && moveCount > 1 && JATEK_FOLYAMATBAN === true) { // ha folyamatban van mar egy jatek
				var r = confirm("Biztos, hogy új játékot kezdesz?");
				if (r == false) {
					if (worker_kereses && helpLoop === false) { // ha keresett a gep akkor ujra inditjuk

						setTimeout(function(){ FindMove(0); }, 100); // ido eltolas a "gameMode" allapot miatt

					} else if (worker_kereses && helpLoop === true) { // ha segitsegkeres kozben nyomtunk nemet az uj jatekra

						setTimeout(function(){ FindMove(1); }, 100); // ido eltolas a "gameMode" allapot miatt

					}
					return false;
				}
			}


			if (id == 3) { // uj jatek menubol ellenoriztunk
				JATEK_FOLYAMATBAN = false; // jatek folyamatban
				moveCount = 0; // lepesek szama
				return true;
			}

			moveCount = 0; // lepesek szama
			OLD_PIECE_NUM = 32; // babuk szama
			EN_PASSANT = 0; // en passant nullazasa
			maxSearchTime = 0; // kereses ido nullazasa
			castleRights = 0x3F; // sancolas nullazasa
			JATEK_FOLYAMATBAN = true; // jatek folyamatban
			LEPES_ELOZMENYEK = []; // lepes elozmenyek uritese
			kingPosition = ((0x4 << 8) | 0x74); // kiraly poziciok nullazasa
			//yourSide = yourSide ? 0 : 8; // Sajat oldalam definialasa uj jatek eseten

			FEN = 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR '+(yourSide ? 'b' : 'w')+' KQkq - 0 0';

			CHESS_BOARD = FENToBoard(); // Tabla feltoltese

			if (yourSide) { // forditott tablanal embert kell valtani a tablarajzolas elott
				currentPlayer = currentPlayer ? 0 : 8; // ezzel elkerulendo a dragable bug
			}

			drawBoard(CHESS_BOARD); // Tabla rajzolasa

			if (yourSide) { // Gep elso lepese Feher oldalon
				var time = id == 4 ? 400 : 100; // menubol : jatek
				setTimeout(function(){ FindMove(0); }, time);  // ido eltolas menubol 0,4s jatek 0,1s
			}

			return true;
		}





	// getPieceName
		function getPieceName(pieceValue) {
			switch (pieceValue) {
				case WHITE_KING: return 'WHITE_KING';
				case WHITE_QUEEN: return 'WHITE_QUEEN';
				case WHITE_ROOK: return 'WHITE_ROOK';
				case WHITE_BISHOP: return 'WHITE_BISHOP';
				case WHITE_KNIGHT: return 'WHITE_KNIGHT';
				case WHITE_PAWN: return 'WHITE_PAWN';
					
				case BLACK_KING: return 'BLACK_KING';
				case BLACK_QUEEN: return 'BLACK_QUEEN';
				case BLACK_ROOK: return 'BLACK_ROOK';
				case BLACK_BISHOP: return 'BLACK_BISHOP';
				case BLACK_KNIGHT: return 'BLACK_KNIGHT';
				case BLACK_PAWN: return 'BLACK_PAWN';
					
				default: return 'EMPTY';
			}
		}





	// getPieceName -> Hungary
		function getPieceName_HUN(pieceValue) {
			switch (pieceValue) {
				case WHITE_KING: return 'Kir&aacute;ly';
				case WHITE_QUEEN: return 'Vez&eacute;r';
				case WHITE_ROOK: return 'B&aacute;stya';
				case WHITE_BISHOP: return 'Fut&oacute;';
				case WHITE_KNIGHT: return 'Husz&aacute;r';
				case WHITE_PAWN: return 'Gyalogos';
					
				case BLACK_KING: return 'Kir&aacute;ly';
				case BLACK_QUEEN: return 'Vez&eacute;r';
				case BLACK_ROOK: return 'B&aacute;stya';
				case BLACK_BISHOP: return 'Fut&oacute;';
				case BLACK_KNIGHT: return 'Husz&aacute;r';
				case BLACK_PAWN: return 'Gyalogos';
					
				default: return 'EMPTY';
			}
		}





	// getPieceValue
		function getPieceValue(pieceName) {
			switch (pieceName) {
				case 'WHITE_KING': return WHITE_KING;
				case 'WHITE_QUEEN': return WHITE_QUEEN;
				case 'WHITE_ROOK': return WHITE_ROOK;
				case 'WHITE_BISHOP': return WHITE_BISHOP;
				case 'WHITE_KNIGHT': return WHITE_KNIGHT;
				case 'WHITE_PAWN': return WHITE_PAWN;
					
				case 'BLACK_KING': return BLACK_KING;
				case 'BLACK_QUEEN': return BLACK_QUEEN;
				case 'BLACK_ROOK': return BLACK_ROOK;
				case 'BLACK_BISHOP': return BLACK_BISHOP;
				case 'BLACK_KNIGHT': return BLACK_KNIGHT;
				case 'BLACK_PAWN': return BLACK_PAWN;
					
				default: return (currentPlayer ? BLACK_QUEEN : WHITE_QUEEN);
			}
		}





	// a tabla elemeit FEN be mentjuk
		function boardToFEN() {
			var piece, emptySquares = 0, FEN = '';
			for (var i=0; i < 128; i++) {
				if (! (i & 0x88) ) {
					var n = CHESS_BOARD[i];
					if ((n & 0x07) === 0x07) { // queen
						piece = 'Q';
					} else if ((n & 0x06) === 0x06) { // rook
						piece = 'R';
					} else if ((n & 0x05) === 0x05) { // bishop
						piece = 'B';
					} else if ((n & 0x03) === 0x03) { // king
						piece = 'K';
					} else if ((n & 0x02) === 0x02) { // knight
						piece = 'N';
					} else if ((n & 0x01) === 0x01) { // pawn
						piece = 'P';
					}
						
					if (n === 0) { // empty square
						piece = '';
						emptySquares++;
					}else{
						piece = emptySquares ? emptySquares + piece : piece;                
						emptySquares = 0;
					}
						
					if (n & 0x08){
						piece = piece.toLowerCase();
					}
						
					FEN += piece;
						
					if (i % 8 === 7) { // end of rank
						if (n === 0) {
						   FEN += emptySquares;
						}
						emptySquares = 0;
						FEN += '/';
					}
				}
			};

			// whose turn?
				
			FEN = FEN.substr(0, FEN.length - 1) + ' ';
			FEN += currentPlayer === 0 ? 'w' : 'b';
			FEN += ' KQkq - 0 0';

			return FEN;
		}






	// FEN bol betoltes a tablara
		function FENToBoard() {
				
			var pieceValueMap = {
				r: BLACK_ROOK,
				n: BLACK_KNIGHT,
				b: BLACK_BISHOP,
				q: BLACK_QUEEN,
				k: BLACK_KING,
				p: BLACK_PAWN,
					
				R: WHITE_ROOK,
				N: WHITE_KNIGHT,
				B: WHITE_BISHOP,
				Q: WHITE_QUEEN,
				K: WHITE_KING,
				P: WHITE_PAWN
			};

			CHESS_BOARD = [];

			var Fen = FEN.split(' ');

			for (var i = 0, len = Fen[0].length; i < len; i++) {
					
				var value = Fen[0][i];
				if (value === '/'){
					for (var j = 0; j < 8; j++) {
						CHESS_BOARD.push(0);
					}
					continue;
				}
						
				if (isNaN(value)) {
					CHESS_BOARD.push(pieceValueMap[value]);
				} else {
					for (var j = 0; j < parseInt(value, 10); j++) {
						CHESS_BOARD.push(0);
					}
				}
			}
				
			for (var j = 0; j < 8; j++) {
				CHESS_BOARD.push(0);
			}
				
			currentPlayer = Fen[1] === 'w' ? 0 : 8; // White : Black

			return CHESS_BOARD;
		}





	// Tabla kirajzolasa
		function drawBoard(BOARD, last_from, last_to, backStepData) {

			var str = '';
			var piece_num = 0;
			var mobil_from = 0;
			last_to = parseInt(last_to);
			last_from = parseInt(last_from);
			var whichPlayer = yourSide ? 0 : 8;
			var incr = whichPlayer ? 1 : -1;
			var start = whichPlayer ? 0 : 127;
			var end = whichPlayer ? 128 : -1;
			var rowStart = whichPlayer ? 0 : 15;
			var rowEnd = whichPlayer ? 15 : 0;

		// kiiras nullazasa
			if (gameMode === 1) { // gep ellen

				$('#game_info').html('Te következel!');

			} else { // 2 jatekos jatszik

				if (moveCount % 2 === 0) {
					$('#game_info').html('Fehér következik!');
				} else {
					$('#game_info').html('Fekete következik!');
				}

			}


		// szamozas
			if (whichPlayer) {
				var board_line = 8;
			} else {
				var board_line = 1;
			}

			str += '<table border="0" cellpadding="0px" cellspacing="0px">'; // Tabla eleje


		// table felepitese
			for ( var i = start ; i !== end ; i+= incr ) 
			{

			// szamozas, betuzes
				var board_cell = i % 16;
				var board_strs = "abcdefgh";
				var board_str = board_strs.substr(board_cell, 1);
				
			// babuk szamolasa->leutes hang miatt kell
				if (BOARD[i])
				{
					piece_num++; // osszes babu szamolasa

					// kiraly pozicio
					if(BOARD[i] === (currentPlayer ? BLACK_KING : WHITE_KING))
					{
						var kingPos = i;
					}
				}

			// tabla rajzolasa
				if ( i % 16 === rowStart ) {
					str += '<tr class="row">';
				}
					
				if (! (i & 0x88) ) {
					str += '<td class="column_td">' + 
								'<div class="column ' + ( (i & 0x1) ^ ((i >> 4)  & 0x1) ? 'dark': 'light') +
								'" data-square="' + i + '" alt="' + board_str + Math.round(board_line) + '">' +
									'<div class="' + getPieceName(BOARD[i]) + '" alt="' + getPieceName_HUN(BOARD[i]) + '"></div>' +
								'</div>' + 
							'</td>';
				}
					
				if ( i % 16 === rowEnd ) {

					str += '</tr>';

				// szamozas
					if (whichPlayer) {
						--board_line;
					} else {
						++board_line;
					}
				}
			}

			str += '</table>'; // Tabla vege


		// tabla html-be
			$('#game_table').html(str);
				

		// utolso lepes
			if (last_from > -1 && last_to > -1)
			{
				$('div[data-square="'+last_to+'"]').addClass('last_step');
				$('div[data-square="'+last_from+'"]').addClass('last_step');


			// Dontetlen ? 2 kiraly maradt vagy 3 lepesismetles
				if ( (piece_num < 3) || (ThreeFoldRep(backStepData) > 2) ) {

					playAudio('game_egal.mp3');

					JATEK_FOLYAMATBAN = false; // jatek stop

					$('#game_info').html('A mérközés döntetlen!'+ (piece_num > 2 ? ' 3 lépésismétlés!' : ' :/'));

					if (path != '') // betoltodott a cordova.js
					{
					// statisztika frissitese gep ellen
						if (gameMode === 1)
						{
							var num = window.localStorage.getItem("dontetlen_stat");
							window.localStorage.setItem("dontetlen_stat", (num ? (parseInt(num) + 1) : 1));
						}

					// Ha van internet-kapcsolat
						document.addEventListener("online", onOnline(false, true), false);

					// uzenet
						return navigator.notification.confirm(
							'A mérközés döntetlen!'+ (piece_num > 2 ? ' 3 lépésismétlés!' : ' :/'), // Uzenet
							Game_Restart, // Funkcio
							'Döntetlen', // Cim
							['Új játék', 'Bezár'] // Gomb
						);
					}

					if (InitializeBackgroundEngine()) WorkerStop(); // Worker eseten a hatter futtatas leallitasa

					return false;

				}


			// sakk van-e?
				if (isSquareUnderAttack(kingPos, currentPlayer)) {

					var SAKK_VAN = true;

					if (gameMode === 1) { // gep ellen

						$('#game_info').html('Sakk! Te következel!');

					} else { // 2 jatekos jatszik

						if (moveCount % 2 === 0) {
							$('#game_info').html('Sakk! Fehér következik!');
						} else {
							$('#game_info').html('Sakk! Fekete következik!');
						}

					}

					$('div[data-square="'+kingPos+'"]').addClass('king_sakk');

				} else {
					var SAKK_VAN = false;
				}


			// Jatek vege ?
				if (GameOver()) {
					JATEK_FOLYAMATBAN = false; // jatek stop

					if (SAKK_VAN) {
						if ((currentPlayer != yourSide) || (gameMode === 2)) { // GYOZELEM kiirasa

							if (gameMode === 1) { // gep ellen
	
								playAudio('game_winner.mp3');

								$('#game_info').html('Te nyertél! Sakk-Matt! :)');

								if (path != '') // betoltodott a cordova.js
								{
								// statisztika frissitese
									var num = window.localStorage.getItem("gyozelem_stat");
									window.localStorage.setItem("gyozelem_stat", (num ? (parseInt(num) + 1) : 1));

								// statisztika frissitese -> legerosebb legyozott szint
									var max_ido = Math.round(ALPHA_BETA_MAX_IDO / 1000);
									var best = window.localStorage.getItem("best_stat");
									window.localStorage.setItem("best_stat", (best ? (parseInt(best) < max_ido ? max_ido : best) : max_ido));

								// Ha van internet-kapcsolat
									document.addEventListener("online", onOnline(false, true), false);

								// uzenet
									return navigator.notification.confirm(
										'Te nyertél! Sakk-Matt! :)', // Uzenet
										Game_Restart, // Funkcio
										'Sakk-Matt', // Cim
										['Új játék', 'Bezár'] // Gomb
									);
								}

							} else { // 2 jatekos jatszik

								playAudio('game_winner.mp3');

								if (moveCount % 2 === 0) {
									var uzenet = 'Fekete nyert! Sakk-Matt! :)'
									$('#game_info').html(uzenet);
								} else {
									var uzenet = 'Fehér nyert! Sakk-Matt! :)'
									$('#game_info').html(uzenet);
								}

								if (path != '') // betoltodott a cordova.js
								{
								// Ha van internet-kapcsolat
									document.addEventListener("online", onOnline(false, true), false);

								// uzenet
									return navigator.notification.confirm(
										uzenet, // Uzenet
										Game_Restart, // Funkcio
										'Sakk-Matt', // Cim
										['Új játék', 'Bezár'] // Gomb
									);
								}

							}

						} else { // VERESEGET csak gep ellen irjuk ki

							playAudio('game_looser.mp3');

							$('#game_info').html('Te vesztettél! Sakk-Matt! :(');

							if (path != '') // betoltodott a cordova.js
							{
							// statisztika frissitese
								var num = window.localStorage.getItem("vereseg_stat");
								window.localStorage.setItem("vereseg_stat", (num ? (parseInt(num) + 1) : 1));

							// Ha van internet-kapcsolat
								document.addEventListener("online", onOnline(false, true), false);

							// uzenet
								return navigator.notification.confirm(
									'Te vesztettél! Sakk-Matt! :(', // Uzenet
									Game_Restart, // Funkcio
									'Sakk-Matt', // Cim
									['Új játék', 'Bezár'] // Gomb
								);
							}
						}
					 } else {

						playAudio('game_egal.mp3');

						$('#game_info').html('A mérközés döntetlen! Patt! :/');

						if (path != '') // betoltodott a cordova.js
						{
						// statisztika frissitese gep ellen
							if (gameMode === 1)
							{
								var num = window.localStorage.getItem("dontetlen_stat");
								window.localStorage.setItem("dontetlen_stat", (num ? (parseInt(num) + 1) : 1));
							}

						// Ha van internet-kapcsolat
							document.addEventListener("online", onOnline(false, true), false);

						// uzenet
							return navigator.notification.confirm(
								'A mérközés döntetlen! Patt! :/', // Uzenet
								Game_Restart, // Funkcio
								'Döntetlen', // Cim
								['Új játék', 'Bezár'] // Gomb
							);
						}
					}

					if (InitializeBackgroundEngine()) WorkerStop(); // Worker eseten a hatter futtatas leallitasa

					return false;

				} else if (SAKK_VAN && piece_num > 2) { // sakk es nem dontetlen

					playAudio('sakk_sakk.mp3');

				}


			// Sakk es utes hang
				 if (!SAKK_VAN && OLD_PIECE_NUM > piece_num) { // utes volt es nem volt sakk

					playAudio('sakk_utes.mp3');

				} else if (!SAKK_VAN) { // sima lepes volt

					playAudio('sakk_lepes.mp3');

				}


				OLD_PIECE_NUM = piece_num; // Babuk szamanak frissitese


			// En passant mentese a tabla rajzolasa utan az ellenfel vagy a gep szamara kell itt is!!
				if ((CHESS_BOARD[last_to] & 0x07) === PAWN && ( Math.abs(last_from - last_to) === 32 )
				&& ((((CHESS_BOARD[last_to-1] & 0x07) === PAWN) && (CHESS_BOARD[last_to] !== CHESS_BOARD[last_to-1]))
					|| (((CHESS_BOARD[last_to+1] & 0x07) === PAWN) && (CHESS_BOARD[last_to] !== CHESS_BOARD[last_to+1]))) )
				{
					var en_passant_direction_diff = (last_from - last_to > 0 ? 16 : -16); // elojeles differencia
					EN_PASSANT = last_to + en_passant_direction_diff; // En passant set
				}
				else
				{
					EN_PASSANT = 0; // En passant unset
				}

			}


		// ellenfel elemeivel nem lephetunk
			$('.column div').filter(function(){
				return $(this).attr('class').indexOf(currentPlayer ?  'BLACK' : 'WHITE') !== -1;
			}).draggable({ revert: 'invalid' });


		if (currentPlayer === yourSide || gameMode === 2) { // Ha mi lephetunk gep ellen, vagy 2 jatekos modban jatszunk

			// ahova lepunk kattintassal
				$('.column').click(function() {
					$('.column').removeClass('red-border');

					if ($(this).find('div').attr('class').indexOf(currentPlayer ?  'BLACK' : 'WHITE') !== -1)
					{
						$(this).addClass('red-border');
						mobil_from = $(this).data('square');
					}

					if (maxSearchTime === 0)
					{
						for (var i = 0; i < 128; i++) {
							if (validateMove($(this).data('square'), i, currentPlayer)) {
								$('.column').filter(function(){
									return $(this).data('square') === i;
								}).addClass('red-border').click(function() {
									onMove(mobil_from, $(this).data('square'));
								});
							}
						}
					}
				});


			// huzhatjuk is a babut
				$('.column').mousedown(function() {
					$('.column').removeClass('red-border').droppable({disabled: true});

					if ($(this).find('div').attr('class').indexOf(currentPlayer ?  'BLACK' : 'WHITE') !== -1)
					$(this).addClass('red-border');

					if (maxSearchTime === 0)
					{
						for (var i = 0; i < 128; i++) {
							if (validateMove($(this).data('square'), i, currentPlayer)) {
								$('.column').filter(function() {
									return $(this).data('square') === i;
								}).addClass('red-border').droppable({disabled: false, drop: onDrop});
							}
						}
					}
				});
			}
		}





	// babu elengedese lepeskor
		function onDrop(event, ui) {
			var to = $(this).data('square');
			var from = $(ui.draggable).parent().data('square');

			onMove(from, to);
		}





	// gyalogos atvaltoztatas
		function pawnPromotion(piece, from, to) {
			REPLACE_PIECE_TO = getPieceValue( $(piece).attr('alt') ); // mentes a tomitankChess.js -be
			self.PIECE_REPLACE = false; // csere jog ki
			global_info_close(); // ablak bezaras
			onMove(from, to); // lepes folytatasa
		}





	// maga a lepes
		function onMove(from, to, USER_HELP, COMPUTER) {

			if (JATEK_FOLYAMATBAN && validateMove(from, to, currentPlayer))
			{

				if (USER_HELP) // Segitseg kijelzese
				{
					maxSearchTime = 0; // keresesi ido nullazasa

					$('div[data-square="'+from+'"], div[data-square="'+to+'"]').switchClass('', 'next_step', 0,
					function() { 
						setTimeout(function(){ 
							$('div[data-square="'+from+'"], div[data-square="'+to+'"]').switchClass('next_step', '', 0, function() {  }); 
						}, 1000);
					}); 

					$('#game_info').html('Te következel!'); // kiiras nullazasa

					return true;
				}

			// gyalogos-csere eseten
				if ((CHESS_BOARD[from] & 0x07) === PAWN && REPLACE_PIECE_TO === 0 && (to < 8 || to >= 112))
				{
					if (currentPlayer) // fekete oldal
					{
						if (COMPUTER) { // gep

							REPLACE_PIECE_TO = BLACK_QUEEN;

						} else { // ember valaszthat
							global_info('<br>Mire cseréled be a gyalogost?<br><br>'
							+'<img src="pic/bQueen.png" class="csere_babu" alt="BLACK_QUEEN" onClick="pawnPromotion(this,'+from+','+to+')">'
							+'<img src="pic/bBishop.png" class="csere_babu" alt="BLACK_BISHOP" onClick="pawnPromotion(this,'+from+','+to+')">'
							+'<img src="pic/bKnight.png" class="csere_babu" alt="BLACK_KNIGHT" onClick="pawnPromotion(this,'+from+','+to+')">'
							+'<img src="pic/bRook.png" class="csere_babu" alt="BLACK_ROOK" onClick="pawnPromotion(this,'+from+','+to+')">');
							return false;
						}

					} else { // feher oldal

						if (COMPUTER) { // gep

							REPLACE_PIECE_TO = WHITE_QUEEN;

						} else { // ember valaszthat
							global_info('<br>Mire cseréled be a gyalogost?<br><br>'
							+'<img src="pic/wQueen.png" class="csere_babu" alt="WHITE_QUEEN" onClick="pawnPromotion(this,'+from+','+to+')">'
							+'<img src="pic/wBishop.png" class="csere_babu" alt="WHITE_BISHOP" onClick="pawnPromotion(this,'+from+','+to+')">'
							+'<img src="pic/wKnight.png" class="csere_babu" alt="WHITE_KNIGHT" onClick="pawnPromotion(this,'+from+','+to+')">'
							+'<img src="pic/wRook.png" class="csere_babu" alt="WHITE_ROOK" onClick="pawnPromotion(this,'+from+','+to+')">');
							return false;
						}
					}
				}

			// lepes attadasa a gepnek
				var backStepData = makeMove(from, to);

			// FEN a tablabol
				FEN = boardToFEN();

			 // lepes elozmeny mentese
				var from_log = $('div[data-square="'+from+'"]').attr('alt'); // honnan
				var to_log = $('div[data-square="'+to+'"]').attr('alt'); // hova

				LEPES_ELOZMENYEK.push({
					data : backStepData,
					from : from_log,
					to : to_log,
					fen : FEN
				});

			// tabla ujra razolasa
				drawBoard(CHESS_BOARD, from, to, backStepData);

				if (JATEK_FOLYAMATBAN) { // Mehet tovabb a jatek

					maxSearchTime = 0; // keresesi ido nullazasa

					if ((currentPlayer != yourSide) && (gameMode === 1)) { // Gepi lepes kovetkezik

						//ido kijelzese
							var max_ido = Math.round(ALPHA_BETA_MAX_IDO / 1000);

						// ertesito update
							if (InitializeBackgroundEngine())
							$('#game_info').html('Türelem, gondolkodok... ('+max_ido+'/0 mp, Mélység 0)');
							else
							$('#game_info').html('Türelem, '+max_ido+' mp-ig gondolkodok...');
							
						// gepi lepes keresese
							setTimeout(function(){ FindMove(0); }, ALPHA_BETA_MAX_IDO < 1000 ? 1000 : 100);

					} else if (gameMode === 2) { // 2 jatekos jatszik

					}

				}
			}
		}





	// FindMove
		function FindMove(USER_HELP) {

			if (JATEK_FOLYAMATBAN === false) { // jatek vege
				$('#game_info').html('Hiba! Nem aktív a mérközés!');
				return false;
			} else if (maxSearchTime !== 0) { // Nem indithat dupla keresest a user
				return false;
			} else if (gameMode !== 1) { // 2 jatekos jatszik egymas ellen
				return false;
			}

			if (USER_HELP) { // BUGFIX: uj jatek vizsgalat utan a gepi idovel keresett volna a gep
				helpLoop = true;
			} else {
				helpLoop = false;
			}

			maxSearchTime = ALPHA_BETA_MAX_IDO; // beallitott ido ezred masodpercben

			bestMove = BookMove(); // Nyitasok Konyvbol

			if (bestMove) { // Ha volt a konyvben egyezo sor

				var book_move = bestMove.split('-');

				$('#game_info').html('Könyv alapján lépek!');

				setTimeout(function(){ onMove(parseInt(book_move[0]), parseInt(book_move[1]), USER_HELP, true); }, 1000); // maga a lepes

				return false;
			}


		// Hatterben kereses Worker-el
			if (InitializeBackgroundEngine()) {

				backgroundEngine.postMessage(["search", maxSearchTime, USER_HELP, CHESS_BOARD, currentPlayer, castleRights, EN_PASSANT, REPLACE_PIECE_TO, kingPosition]);

			}
		// Ha nem tamogatja a bongeszo a Worker-t
			else
			{

				for(var i = 0; i < 3 * 64; i++) { // Gyilkos tabla uritese
					searchKillers[i] = 0;
				}

				for (var i = 0; i < 32; i++) { // Elozmeny tabla uritese
					historyTable[i] = new Array(128);
					for (var j = 0; j < 128; j++) {
						historyTable[i][j] = 0;
					}
				}

				g_startTime = (new Date()).getTime(); // kezdo ido
				timeStop = false; // ido vege nullazas
				bestMove = false; // lepes nullazas
				var alpha = -maxEval;
				var beta = maxEval;
				var bestNext = -1;
				var bestFrom = -1;
				var maxDepth = 64;
				boardPly = 0; // nullazas
				nodes = 0; //csomopont nullazas

				if (USER_HELP) { // Segitseg maxmum 2 masodpercig
					maxSearchTime = maxSearchTime > 2000 ? 2000 : maxSearchTime;
				}

				for (var i=1; i < maxDepth && !timeStop; i++) // iterativ melyites
				{
					var Score = AlphaBeta(alpha, beta, i, i, 0, true, true); // lepes kereses (Alpha, Beta, Depth, MaxDepth, worker, firstMove, nullMove)

					if (timeStop === true && bestFrom !== -1) break; // Ido vagas

					bestFrom = (bestMove >> 24) & 0xFF;
					bestNext = (bestMove >> 16) & 0xFF;

					// console.log('BestMove: '+bestFrom+'|'+bestNext+' Depth: '+i+ " Score: "+Score+" Nodes: "+nodes);

					if (Score > alpha && Score < beta) { // alpha-beta Ablak
						alpha = Score - 50;
						beta = Score + 50;

						if (alpha < -maxEval) alpha = -maxEval;
						if (beta > maxEval) beta = maxEval;
					} else if (alpha != -maxEval) { // Ha kilogunk az ablakbol..
						alpha = -maxEval;
						beta = maxEval;
						i--;
					}
				}

				return onMove(bestFrom, bestNext, USER_HELP, true); // maga a lepes
			}
		}





	// Opben BOOK >> GEP ELLENI NYITASOK
		function printGameLine() {
			var moveNum = 0;
			var gameLine = "";
			for(moveNum = 0; moveNum < moveCount; ++moveNum) {
				var move = LEPES_ELOZMENYEK[moveNum];
				gameLine += move.from +''+ move.to + " ";
			}
			return $.trim(gameLine);
		}


		function LineMatch(BookLine, gameline) {
			for(var len = 0; len < gameline.length; ++len) {
				if(len >= BookLine.length) { return false;	}	
				if(gameline[len] != BookLine[len]) { return false;	}	
			}
			return true;
		}


		function BookMove() {

			var bookMoves = [];
			var gameLine = printGameLine();
			var lengthOfLineHack = gameLine.length;
			
			if(gameLine.length == 0) lengthOfLineHack--;
			
			for(var bookLineNum = 0; bookLineNum < brd_bookLines.length; ++bookLineNum) {
				
				if(LineMatch(brd_bookLines[bookLineNum], gameLine) == true) {
					var move = brd_bookLines[bookLineNum].substr(lengthOfLineHack + 1, 4);
					if(move.length == 4) {
						var from = $('div[alt="'+move.substr(0,2)+'"]').attr('data-square');
						var to = $('div[alt="'+move.substr(2,2)+'"]').attr('data-square');
						bookMoves.push(from+'-'+to);
					} 
				}
				  
			}
				
			if(bookMoves.length == 0) return false;
			
			var num = Math.floor(Math.random()*bookMoves.length);
			
			return bookMoves[num];
		}






	// Gep_Erosseg Allitasa
		function Gep_Erosseg(id, ellenor) {

			if (maxSearchTime != 0 && JATEK_FOLYAMATBAN === true) // csak ha mi kovetkezunk
			{
				$('select').val(ALPHA_BETA_MAX_IDO); // Erosseg alaphelyzetbe
				return false;
			}
			else if (ellenor || moveCount <= 1 || JATEK_FOLYAMATBAN === false) // erosseg allitasa
			{
				var maxIdo = parseInt(id);

				if (maxIdo > 0 && maxIdo < 30001)
				{
					if (id == 8001) {
						EXTREM_WORKER_NELKUL = true; // extrem worker nelkul BE
					} else {
						EXTREM_WORKER_NELKUL = false; // extrem worker nelkul KI
					}

					ALPHA_BETA_MAX_IDO = maxIdo;

					if (ellenor) Game_Restart(0); // jatek ujrainditasa

					// console.log(Math.round(ALPHA_BETA_MAX_IDO / 1000)+''+(EXTREM_WORKER_NELKUL ? '+' : '')+' szintu erosseg kivalasztva!');
				} else {
					$('select').val(ALPHA_BETA_MAX_IDO); // Erosseg alaphelyzetbe
				}
			}
			else // nem engedunk erosseget allitani a merkozes kozepen
			{
				var r = confirm("Erősség állításakor újraindul a játék!");
				if (r == true) {
					Gep_Erosseg(id, true);
				} else {
					$('select').val(ALPHA_BETA_MAX_IDO); // Erosseg alaphelyzetbe
				}
			}
		}





	// Back_Step
		function Back_Step() {

			if (moveCount > 1 && JATEK_FOLYAMATBAN === true && maxSearchTime === 0)
			{
				var gepi_lepes = LEPES_ELOZMENYEK[LEPES_ELOZMENYEK.length-1];
				var emberi_lepes = LEPES_ELOZMENYEK[LEPES_ELOZMENYEK.length-2];

				var gepi_to = $('div[alt="'+gepi_lepes.to+'"]').attr('data-square');
				var gepi_from = $('div[alt="'+gepi_lepes.from+'"]').attr('data-square');
				var emberi_to = $('div[alt="'+emberi_lepes.to+'"]').attr('data-square');
				var emberi_from = $('div[alt="'+emberi_lepes.from+'"]').attr('data-square');

				unMakeMove(parseInt(gepi_from), parseInt(gepi_to), parseInt(gepi_lepes.data)); // gepi lepes visszavonasa
				unMakeMove(parseInt(emberi_from), parseInt(emberi_to), parseInt(emberi_lepes.data)); // jatekos lepes visszavonasa

				OLD_PIECE_NUM = 0; // babuk nullazasa
				FEN = boardToFEN(); // FEN letrehozasa
				CHESS_BOARD = FENToBoard(); // Tabla feltoltese
				for (var i = 0; i < 128; i++)
				{
					if (CHESS_BOARD[i])
					OLD_PIECE_NUM++; // babuk szama noveles
				}

				drawBoard(CHESS_BOARD); // Ujra rajzoljuk a tablat

				LEPES_ELOZMENYEK.splice(LEPES_ELOZMENYEK.length-2, 2); // elozmeny torlese
			}

		}





	 // 3 lepesismetleses dontetlen
		function ThreeFoldRep(backStepData) {
			var r = 0;
			if (gameMode === 1) return r; // csak multiban!!

			for (var i = 0; i < moveCount; ++i)	{
				if (LEPES_ELOZMENYEK[i].fen == FEN && LEPES_ELOZMENYEK[i].data == backStepData) {
					r++;
				}
			}
			return r;
		}





	 // Worker (.js hatter futtatas) leallitasa
		function WorkerStop() {
			backgroundEngine.terminate();
			backgroundEngine = null;
		}





	// Worker (.js hatterbe futas)
		function InitializeBackgroundEngine() {
			if (!backgroundEngineValid || EXTREM_WORKER_NELKUL) {
				return false;
			}

			if (backgroundEngine == null) 
			{
				backgroundEngineValid = true;
				try 
				{
					backgroundEngine = new Worker("js/tomitankChess.js");

					backgroundEngine.onmessage = function (e) {
						if (e.data[0] == "Move")
						{
							//WorkerStop(); // hatter futtatas leallitasa
							onMove(e.data[1], e.data[2], e.data[3], true); // gepi lepes ervenyesitese vagy segitseg mutatasa
						}
						else if (e.data[0] == "Error")
						{
							WorkerStop(); // hatter futtatas leallitasa
							$('#game_info').html(e.data[1]); // Hiba ertesites kiirasa
						}
						else if (e.data[0] == "Message")
						{
							$('#game_info').html(e.data[1]); // ertesites kiirasa
						}
						else if (e.data[0] == "Redraw")
						{
							drawBoard(e.data[1]); // aktualis allas kirajzolasa
						}
					}

					backgroundEngine.error = function (e) 
					{
						alert("Hiba a Worker Feldolgozasaban:" + e.message);
					}
				} 
				catch (error) 
				{
					backgroundEngineValid = false;
				}
			}

			return backgroundEngineValid;
		}

